/****************************************************************************/
/* Ώۃ}CR R8C/35A                                                     */
/* ̧ٓe     I2CɂEEP-ROM(24C256B)                               */
/* o[W   Ver.1.20                                                    */
/* Date         2010.04.19                                                  */
/* Copyright    lTX}CRJ[[                            */
/*              C^[fBbNX                            */
/****************************************************************************/

/*======================================*/
/* CN[h                         */
/*======================================*/
#include    <stdio.h>
#include    "sfr_r835a.h"               /* R8C/35A SFR̒`t@C    */
#include    "i2c_eeprom_lib.h"          /* EEP-ROM֘A              */

/*======================================*/
/* V{`                         */
/*======================================*/

/* setPageWriteI2CEeprom֐PŕۑoTCY */
#define EEP_SAVE_SIZE       16          /* őۑ                   */

/* ̑` */
#define ACK                 0           /* [hACKL(ACK=0)     */
#define NO_ACK              1           /* [hACK(ACK=1)     */

#define STOP_RD             0           /* Xgbv̒O͓ǂݍ     */
#define STOP_WR             1           /* Xgbv̒O͏     */

/*======================================*/
/* O[oϐ̐錾                 */
/*======================================*/

static unsigned char    eep_address;        /* AhX̑I           */
static int              write_mode;         /* e                 */
static unsigned char    write_eep_address;  /* EEP-ROM̃AhX*/
static unsigned int     write_address;      /* ݃AhX         */
static int              write_count;        /* ݌             */
static char             write_buff[EEP_SAVE_SIZE];/* ݃f[^ۑobt@*/
static char             *write_buff_p;      /* ݃f[^ǂݍ݈ʒu*/

/*======================================*/
/* vg^Cv錾                     */
/*======================================*/

/************************************************************************/
/* W[ i2c_start                                               */
/* Tv     X^[g֘AWX^ݒAX^[gMM              */
/************************************************************************/
void i2c_start( void )
{
    stop_icsr = 0;
    while( bbsy_iccr2 == 1 );
    iccr1 |= 0x30;                      /* }X^M[h             */
    iccr2 = 0x90;                       /* X^[gs             */
}

/************************************************************************/
/* W[ i2c_stop                                                */
/* Tv     XgbvMM                                        */
/************************************************************************/
void i2c_stop( int mode )
{
    if( mode == STOP_WR ) {
        iccr2 = 0x10;                   /* Xgbvs             */
        tend_icsr = 0;
        nackf_icsr = 0;
        while(stop_icsr == 0);
        stop_icsr = 0;
    }
    iccr1 &= 0xcf;                      /* X[uM[h           */
}

/************************************************************************/
/* W[ i2c_write                                               */
/* Tv     EEP-ROM@PoCg                               */
/*          char            f[^                                  */
/* ߂l       int             acknowledge 0:L  1:              */
/************************************************************************/
int i2c_write( char data )
{
    int ret;

    icdrt = data;
    while( tdre_icsr == 0 );
    while( tend_icsr == 0 );

    ret = ackbr_icier;

    return ret;
}

/************************************************************************/
/* W[ i2c_read                                                */
/* Tv     EEP-ROM@PoCgǂݍ                               */
/*          int ACKFf[^ NO_ACKFf[^I                */
/* ߂l       char f[^                                             */
/************************************************************************/
char i2c_read( int ack )
{
    char    ret;

    tend_icsr = 0;
    iccr1 &= 0xef;
    tdre_icsr = 0;
    ackbt_icier = 1;
    ret = icdrr;                        /* _~[[h                 */

    if( ack == NO_ACK ) {
        rcvd_iccr1 = 1;                 /* ̎M֎~           */
    }

    while( rdrf_icsr == 0 );
    iccr2 = 0x10;
    while( stop_icsr == 0 );
    ret = icdrr;
    rcvd_iccr1 = 0;
    ackbt_icier = 0;

    return ret;
}

/************************************************************************/
/* W[ initI2CEeprom                                           */
/* Tv     EEP-ROM̃|[g                                   */
/*          EEP-ROM̌qĂPDi|[g̎w(&t)         */
/*              EEP-ROM̌qĂPi|[g̎w(&t)          */
/*              DDR|[g̓o͐ݒl                                 */
/*              EEP-ROMSCL[q̌qĂrbgԍ                */
/*              EEP-ROMSDA[q̌qĂrbgԍȂ            */
/* ߂l       Ȃ                                                    */
/************************************************************************/
void initI2CEeprom( void )
{
    pd3 &= 0x5f;                        /* P3_7:SDA P3_5:SCL            */

    iicsel = 1;
    stop_icsr = 0;
    ice_iccr1 = 1;
    icmr  = 0x00;
    iccr1 = 0x82;
    icier = 0x00;
    icsr  = 0x00;
    sar   = 0x00;

    selectI2CEepromAddress( 0 );        /* AhX̑I               */
    write_mode  = 0;
}

/************************************************************************/
/* W[ selectI2CEepromAddress                                  */
/* Tv     ǂ̔ԍEEP-ROMgp邩I                       */
/*          unsigned char   EEP-ROM̃AhX 0`3                  */
/* ߂l       Ȃ                                                    */
/************************************************************************/
void selectI2CEepromAddress( unsigned char address )
{
    address &= 0x03;
    eep_address = address << 1;
}

/************************************************************************/
/* W[ readI2CEeprom                                           */
/* Tv     EEP-ROMǂݍ                                         */
/*          unsigned long   AhX 0-32767                        */
/* ߂l       char            f[^                                  */
/************************************************************************/
char readI2CEeprom( unsigned long address )
{
    char    ret;

    asm( "FCLR I" );                    /* Ŝ̊荞݋֎~           */

    i2c_start();
    i2c_write( 0xa0 | eep_address );    /* device address(write)        */
    i2c_write( (address >> 8) & 0xff ); /* first address                */
    i2c_write( address & 0xff );        /* second address               */
    iccr2 = 0x90;                       /* X^[gđ                 */
    i2c_write( 0xa1 | eep_address );    /* device address(read)         */
    ret = i2c_read( NO_ACK );           /* data read                    */
    i2c_stop( STOP_RD );

    asm( "FSET I" );                    /* Ŝ̊荞݋           */

    return ret;
}

/************************************************************************/
/* W[ writeI2CEeprom                                          */
/* Tv     EEP-ROM                                         */
/*          unsigned long AhX 0-32767 ,char f[^             */
/* ߂l       Ȃ                                                    */
/************************************************************************/
void writeI2CEeprom( unsigned long address, char write )
{
    int i;

    asm( "FCLR I" );                    /* Ŝ̊荞݋֎~           */

    i2c_start();
    i2c_write( 0xa0 | eep_address );    /* device address(write)        */
    i2c_write( (address >> 8) & 0xff ); /* first address                */
    i2c_write( address & 0xff );        /* second address               */
    i2c_write( write );                 /* data write                   */
    i2c_stop( STOP_WR );

    asm( "FSET I" );                    /* Ŝ̊荞݋           */
}

/************************************************************************/
/* W[ setPageWriteI2CEeprom                                   */
/* Tv     EEP-ROMy[W                                   */
/*              ̊֐Ńy[W݂Jn                      */
/*          unsigned long AhX 0-32767 , int ,              */
/*              char* f[^AhX                              */
/* ߂l       Ȃ                                                    */
/************************************************************************/
void setPageWriteI2CEeprom( unsigned long address, int count, char* data )
{
    /* ݒȂ炱̊֐͒~ */
    if( write_mode != 0 ) return;

    write_mode          = 1;
    write_eep_address   = eep_address;
    write_address       = address;
    write_count         = count;
    write_buff_p        = write_buff;

    if( count >= EEP_SAVE_SIZE ) count = EEP_SAVE_SIZE;
    do {
        *write_buff_p++ = *data++;
    } while( --count );

    write_buff_p = write_buff;
}

/************************************************************************/
/* W[ I2CEepromProcess                                        */
/* Tv     EEP-ROMy[W                                   */
/*          Ȃ                                                    */
/* ߂l       Ȃ                                                    */
/************************************************************************/
void I2CEepromProcess( void )
{
    asm( "FCLR I" );                    /* Ŝ̊荞݋֎~           */

    switch( write_mode ) {
    case 1:
        i2c_start();
        write_mode = 2;
        break;
    case 2:
        i2c_write( 0xa0 | write_eep_address );  /* device address(write)*/
        write_mode = 3;
        break;
    case 3:
        i2c_write( (write_address >> 8) & 0xff );   /* first address    */
        write_mode = 4;
        break;
    case 4:
        i2c_write( write_address & 0xff );      /* second address       */
        write_mode = 5;
        break;
    case 5:
        i2c_write( *write_buff_p++ );           /* data write           */
        if( !(--write_count) ) write_mode = 6;
        break;
    case 6:
        i2c_stop( STOP_WR );
        write_mode = 0;
        break;
    }

    asm( "FSET I" );                    /* Ŝ̊荞݋           */
}

/************************************************************************/
/* W[ clearI2CEeprom                                          */
/* Tv     EEP-ROM@I[NA                                   */
/*          Ȃ                                                    */
/* ߂l       Ȃ                                                    */
/************************************************************************/
void clearI2CEeprom( void )
{
    unsigned int    address = 0;
    int             i;

    asm( "FCLR I" );                    /* Ŝ̊荞݋֎~           */

    while( 1 ) {
        i2c_start();
        i2c_write( 0xa0 | eep_address ); /* device address(write)       */
        i2c_write( address >> 8 );      /* first address                */
        i2c_write( address & 0xff );    /* second address               */
        for( i=0; i<64; i++ ) {
            i2c_write( 0 );             /* data write                   */
        }
        i2c_stop( STOP_WR );

        while( !checkI2CEeprom() );     /* wait                         */

        address += 64;
        if( address >= 32768 ) break;
    }

    asm( "FSET I" );                    /* Ŝ̊荞݋           */
}

/************************************************************************/
/* W[ checkI2CEeprom                                          */
/* Tv     EEP-ROM݌Aɓǂݏł邩`FbN         */
/*          Ȃ                                                    */
/* ߂l       1:ǂݏOK 0:܂                                   */
/************************************************************************/
int checkI2CEeprom( void )
{
    int ret;

    if( write_mode != 0 ) return 0;

    asm( "FCLR I" );                    /* Ŝ̊荞݋֎~           */

    i2c_start();
    ret = !i2c_write( 0xa0 | eep_address ); /* device address(write)    */
    i2c_stop( STOP_WR );

    asm( "FSET I" );                    /* Ŝ̊荞݋           */

    return ret;
}

/************************************************************************/
/* end of file                                                          */
/************************************************************************/
