//------------------------------------------------------------------------------
// Ώۃ}CR R8C/35A
// ̧ٓe     ȈՌv^C}vO
// Date         2011.03.16 Ver.1.00
//              2020.09.24 Ver.2.00(T[{ǉȂ)
// Copyright    lTX}CRJ[[
//              C^[fBbNX
//              }CRJ[[wғLủ
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
// CN[h
//------------------------------------------------------------------------------
#include    "sfr_r835a.h"
#include    "dotmatrix_font.h"

//------------------------------------------------------------------------------
// V{`
//------------------------------------------------------------------------------
#define Def_500Hz       4999            // 500Hz:(1/500)/(1/(20000000/8))-1
#define Def_1000Hz      2499            // 1000Hz:(1/1000)/(1/(20000000/8))-1

#define Def_C3          19083           // h:(1/131)/(1/(20000000/8))-1
#define Def_D3          17006           // :(1/147)/(1/(20000000/8))-1
#define Def_E3          15151           // ~:(1/165)/(1/(20000000/8))-1
#define Def_F3          14285           // t@:(1/175)/(1/(20000000/8))-1
#define Def_G3          12754           // \:(1/196)/(1/(20000000/8))-1
#define Def_A3          11362           // :(1/220)/(1/(20000000/8))-1
#define Def_B3          10120           // V:(1/247)/(1/(20000000/8))-1
#define Def_C4          9541            // h:(1/262)/(1/(20000000/8))-1

#define DI()            asm("FCLR I")   // 荞݋֎~
#define EI()            asm("FSET I")   // 荞݋

#define SERVO_CYCLE     39999           // T[{[^PWM̎
#define SERVO_HEI       3830            // T[{ ̂Ƃ
#define SERVO_KAI       1550            // T[{ ĴƂ
#define SERVO_OFF       40000           // T[{ OFF(͂Ȃ)

#define SENSOR          (p0_0)          // ZT[̃|[g
#define SW              (pushsw())      // X^[g^ZbgXCb`̃|[g

#define set_servo(x)    trdgrd1 = (x)   // T[{ OÑpX

//------------------------------------------------------------------------------
// ֐vg^Cv̐錾
//------------------------------------------------------------------------------
void init( void );
void timer( unsigned long timer_set );
void beep( int data1 );
unsigned char dipsw( void );
unsigned char pushsw( void );
void led_out( unsigned char led );
void makeTimeData( void );
void clearTimeData( void );
void dotmatrix( unsigned short *data1 );
void dotmatrix_reverse( unsigned short *data1 );

//------------------------------------------------------------------------------
// O[oϐ̐錾
//------------------------------------------------------------------------------
unsigned long   cnt0 = 0;               // timer֐p
unsigned long   cnt1 = 0;               // mainŎgp
int             mode;
int             dotmatrix_x;
int             mode_t;
int             sensor_cnt;
int             f_start;
int             f_goal;
int             f_servo;
unsigned short  dotmatrixdata_data[34];

// v֌W
int             clock_cnt;
int             clock_flag;
int             min;
int             sec;
int             subsec;

//------------------------------------------------------------------------------
// CvO
//------------------------------------------------------------------------------
void main(void)
{
    int i;
    
    init();                             // 
    EI();                               // 荞݋

    while( 1 ){
        // \f[^XV 10msɂP
        if( clock_cnt >= 10 ) {
            clock_cnt = 0;
            makeTimeData();
        }

        // \
        if( !( dipsw() & 0x08 ) ){
            dotmatrix( dotmatrixdata_data );            // \
        }else{
            dotmatrix_reverse( dotmatrixdata_data );    // t\
        }
    }
}

//------------------------------------------------------------------------------
// R8C/35A̓Ӌ@\̏
//------------------------------------------------------------------------------
void init( void )
{
    unsigned char i = 0;

    // 荞݋֎~
    DI();

    // NbNHXINNbNݒ
    prc0 = 1;

    cm13 = 1;
    cm05 = 0;
    for( i=0; i<50; i++ );
    ocd2 = 0;

    prc0 = 0;

    // I/O|[g̓o͐ݒ
    pu00 = 1;                       // P00 to P03 pull-up
    prc2 = 1;                       // pd0WX^ւ̏݋
    pd0 = 0xfe;

    p1  = 0x0f;
    pd1 = 0xdf;                     // P1_0`P1_3:LED
                                    // P1_4:TXD0
                                    // P1_5:RXD0
    pu04 = 1;                       // P20 to P23 pull-up 
    pd2 = 0xfe;                     // P2_0:XCb`
                                    // P2_1:AIN1
                                    // P2_2:PWMA
                                    // P2_3:BIN1
                                    // P2_4:PWMB
                                    // P2_5:SERVO
                                    // P2_6:AIN2
                                    // P2_7:BIN2
    pd3 = 0xfb;                     // P3_2:ԊOM
                                    // P3_4:uU[
    pd4 = 0x80;                     // P4_2:VREF
                                    // P4_3`P4_5:DIPSW
                                    // P4_6:XIN
                                    // P4_7:XOUT
    pd5 = 0x40;                     // P5_7:DIPSW
    pd6 = 0xff;                     // P6_7:\ENABLE\
                                    // P6_6:LATCH
                                    // P6_5:\SCLR\
                                    // P6_4:SCLK
                                    // P6_3:ROWA_SIN    sA
                                    // P6_2:ROWB_SIN    sB
                                    // P6_1:COL_SIN     
                                    // P6_0:

    mstcr = 0x00;                   // W[Xgbv

    // ^C}RCPWM[h
    trccr1 = 0xb0;                  // JEg\[Xf8
    trcgra = 0;                     // dTE_̎
    trcgrc = 0;                     // dTE_̃f[eB
    trccr2 = 0x02;                  // TRCIOC[q̓ANeBuxH
    trcoer = 0x0b;                  // TRCIOC[q̏o͋
    trcpsr1 = 0x02;                 // TRCIOC[qP3_4Ɋ蓖
    trcmr = 0x8a;                   // JEgJn

    // ^C}RD̃ZbgPWM[h
    trdpsr0 = 0x08;                 // TRDIOB0[qP2_2Ɋ蓖
    trdpsr1 = 0x05;                 // TRDIOB1[qP2_5Ɋ蓖
                                    // TRDIOA1[qP2_4Ɋ蓖
    trdmr = 0xf0;                   // WX^obt@ɂ
    trdfcr = 0x01;                  // ZbgPWM[hɐݒ
    trdoer1 = 0xcd;                 // TRDIOB1̏o͋
                                    // TRDIOA1̏o͋
                                    // TRDIOB0[q̏o͋
    imiea_trdier0 = 1;              // TRD0 IMIEA荞݋
    trdcr0 = 0x23;                  // JEg\[Xf8
    trdgra0 = trdgrc0 = SERVO_CYCLE;// 
    trdgrb0 = trdgrd0 = 0;          // TRDIOB0[qi[^j
    trdgra1 = trdgrc1 = 0;          // TRDIOA1[qiE[^j
    trdgrb1 = trdgrd1 = SERVO_OFF;  // TRDIOB1[qiT[{j
    trd0ic = 7;                     // ^C}RD0̊荞݃xݒ
    trdstr = 0x0d;                  // JEgJn

    while( trd0 <= 250 );           // 100us(400n*250)҂

    // ^C}RB1ms荞ݐݒ 50ns*(trbpre+1)*(trbpr+1)=1ms
    trbmr  = 0x00;                  // JEg\[Xf1
    trbpre = 200 - 1;               // vXP[
    trbpr  = 100 - 1;               // vC}JE^
    trbic  = 6;                     // ^C}RB̊荞݃xݒ
    trbcr  = 0x01;                  // JEgJn

    p6_5 = 0;                       // f[^NA
    p6_5 = 1;

    p6_7 = 1;                       // o͋֎~
    p6_7 = 0;                       // o͋
}

//------------------------------------------------------------------------------
// ^C}RB荞(1msƂ̊荞)
//------------------------------------------------------------------------------
#pragma interrupt intTRBIC (vect=24)
void intTRBIC( void )
{
    EI();       // 荞݋

    cnt0++;
    cnt1++;

    // \f[^쐬^C~OpJEg
    clock_cnt++;

    // ^C̃JEgAbv
    if( clock_flag ) {
        subsec++;
        if( subsec >= 1000 ) {
            subsec = 0;
            sec++;
            if( sec >= 60 ) {
                sec = 0;
                min++;
                if( min >= 100 ) {
                    min = 0;
                }
                if( min < 10 ) {
                    mode_t = 1;
                } else {
                    mode_t = 2;
                }
            }
        }
    }

    // LED bit3=ZT̏ bit2-0:ZTʉ߉
    led_out( (SENSOR << 3) + (sensor_cnt & 0x07) ); 

    // ^Cv
    switch ( mode ) {
    case 0:
        // XCb`͑҂
        if( SW == 1 ) {
            f_servo = 0;
            mode = 1;
        }
        break;

    case 1:
        // X^[go[JƓ邽߂ɑ҂
        if( f_servo != 0 ) {
            clearTimeData();
            clock_flag = 1;
            set_servo( SERVO_KAI );
            f_start = 1;
            cnt1 = 0;
            mode = 2;
        }
        break;

    case 2:
        // PbAT[{𖳕ׂɂ
        if( cnt1 >= 1000 ) {
            set_servo( SERVO_OFF );
            cnt1 = 0;
            mode = 3;
        }
        break;
        
    case 3:
        // ZTi}CRJ[ʉ߁jH
        if( SENSOR == 1 ) {
            sensor_cnt++;  
            cnt1 = 0; 
            if( sensor_cnt == (dipsw() & 0x07) ) {
                // fBbvXCb`(2bit){Qʉ߂S[
                clock_flag = 0;
                f_goal = 1;
                mode = 5;
            } else {
                // ȊOȂAʉ
                mode = 4;
            }
        }
        if( SW == 1 ) {
            // XCb`ꂽ烊Zbg
            mode = 91;
        }
        break;

    case 4:
        // ZTOFFɂȂ܂ő҂Aʉ߃`FbNɖ߂
        if( SENSOR == 1 ) {
            cnt1 = 0;
        } 
        if( cnt1 >= 1000 ) {
            cnt1 = 0;
            mode = 3;
        }
        if( SW == 1 ) {
            // XCb`ꂽ烊Zbg
            mode = 91;
        }
        break;

    case 5:
        // ZTOFFɂȂ܂ő҂A
        if( SENSOR == 1 ) {
            cnt1 = 0;
        } 
        if( cnt1 >= 1000 ) {
            cnt1 = 0;
            mode = 6;
        }
        if( SW == 1 ) {
            // XCb`ꂽ烊Zbg
            mode = 91;
        }
        break;

    case 6:
        // ZbgXCb`҂AZTT[{삳ɃX^[g
        if( SENSOR == 1 ) {
            clearTimeData();
            clock_flag = 1;
            sensor_cnt++;  
            f_start = 1;
            cnt1 = 0;
            mode = 1;
        } 
        if( SW == 1 ) {
            // XCb`ꂽ烊Zbg
            mode = 91;
        }
        break;
        
    case 91:
        // ZbgXCb`AT[{
        clearTimeData();
        set_servo( SERVO_HEI );
        cnt1 = 0;
        mode = 92;
        break;
        
    case 92:
        // 1bAT[{𖳕ׂɂmode=0֖߂
        if( SW == 1 ) {
            cnt1 = 0;
        }
        if( cnt1 >= 1000 ) {
            set_servo( SERVO_OFF );
            mode = 0;
        }
        break;
    }
}

//------------------------------------------------------------------------------
// ^C}RD0荞(T[{ւ̃pXグɊ荞ݔ)
//------------------------------------------------------------------------------
#pragma interrupt intTRD0IC (vect=8)
void intTRD0IC( void )
{
    imfa_trdsr0 = 0;
    
    f_servo = 1;    // T[{ւ̃pX𗧂グuԂɃtO𗧂Ă
}

//------------------------------------------------------------------------------
// ԉ҂
//          ^C}l 1=1ms
// ߂l       Ȃ
//------------------------------------------------------------------------------
void timer( unsigned long data1 )
{
        cnt0 = 0;
        while( cnt0 < data1 );
}

//------------------------------------------------------------------------------
// 炷
//          (1/̎g)/(1/(NbNg/8))-1
// ߂l       Ȃ
//------------------------------------------------------------------------------
void beep( int data1 )
{
    trcgra = data1;                 // ̐ݒ
    trcgrc = data1 / 2;             // f[eB50%̂ߎ̔̒l
}

//------------------------------------------------------------------------------
// DIPXCb`Ԍo
//          Ȃ
// ߂l       0`15ADIPXCb`ON̏ꍇAΉrbg0ɂȂ܂B
//------------------------------------------------------------------------------
unsigned char dipsw( void )
{
    volatile unsigned char  data1;

    data1 = ( ( p5 >> 4 ) & 0x08 ) | ( ( p4 >> 3 ) & 0x07 );

    return( data1 );
}

//------------------------------------------------------------------------------
// vbVXCb`Ԍo
//          Ȃ
// ߂l       XCb`ĂȂꍇ:0Aꂽꍇ:1
//------------------------------------------------------------------------------
unsigned char pushsw( void )
{
    unsigned char data1;

    data1 = ~p2;
    data1 &= 0x01;

    return( data1 );
}

//------------------------------------------------------------------------------
// }CRLEDo                                                  
// @ XCb`l 0`15                                              
//------------------------------------------------------------------------------
void led_out( unsigned char led )
{
    unsigned char data;

    led = ~led;
    led &= 0x0f;
    data = p1 & 0xf0;
    p1 = data | led;
}

//------------------------------------------------------------------------------
// hbg}gNXLED@\f[^쐬
//------------------------------------------------------------------------------
void makeTimeData( void )
{
    unsigned short *r, *w, *s, *g;
    int i,j;

    // \f[^@
    switch( mode_t ){
        case 0:
            r = (unsigned short *)dotmatrixdata_moto2;
            break;
        case 1:
            r = (unsigned short *)dotmatrixdata_moto3;
            break;
        case 2:
            r = (unsigned short *)dotmatrixdata_moto4;
            break;
        case 3:
            r = (unsigned short *)dotmatrixdata_moto1;
            break;
    }
    if( !f_start ){
        s = (unsigned short *)dotmatrixdata_start;
    }else if( f_goal ){
        s = (unsigned short *)dotmatrixdata_goal;
    }else{
        s = (unsigned short *)dotmatrixdata_moto0;
    }
    w = dotmatrixdata_data;
    for( i=0; i<32; i++ ) {
        *w++ = (*r++) | (*s++);
    }

    if( clock_flag ){
        if( subsec >= 500 ) {
            r = (unsigned short *)dotmatrixdata_moto0;
            w = dotmatrixdata_data;
            for( i=0; i<32; i++ ) {
                *w++ = *r++;
            }
        }
    }

    switch( mode_t ){
        case 0:
            // 10sec
            i = sec / 10;
            w = dotmatrixdata_data + 1;
            r = (unsigned short *)dotmatrixdata_suuzi_big + i * 7;
            for( j = 0; j < 7; j++ ){
                *w++ |= *r++;
            }
            
            // 1sec
            i = sec % 10;
            w = dotmatrixdata_data + 8;
            r = (unsigned short *)dotmatrixdata_suuzi_big + i * 7;
            for( j = 0; j < 7; j++ ){
                *w++ |= *r++;
            }

            // 100subsec
            i = subsec / 100;
            w = dotmatrixdata_data + 18;
            r = (unsigned short *)dotmatrixdata_suuzi_big + i * 7;
            for( j = 0; j < 7; j++ ){
                *w++ |= *r++;
            }
            // 10subsec
            i = subsec / 10;
            i = i % 10;
            w = dotmatrixdata_data + 25;
            r = (unsigned short *)dotmatrixdata_suuzi_big + i * 7;
            for( j = 0; j < 7; j++ ){
                *w++ |= *r++;
            }
            break;
        case 1:
            // 1min
            i = min % 10;
            w = dotmatrixdata_data + 0;
            r = (unsigned short *)dotmatrixdata_suuzi_big + i * 7;
            for( j = 0; j < 7; j++ ){
                *w++ |= *r++;
            }
            // 10sec
            i = sec / 10;
            w = dotmatrixdata_data + 9;
            r = (unsigned short *)dotmatrixdata_suuzi_big + i * 7;
            for( j = 0; j < 7; j++ ){
                *w++ |= *r++;
            }
            // 1sec
            i = sec % 10;
            w = dotmatrixdata_data + 16;
            r = (unsigned short *)dotmatrixdata_suuzi_big + i * 7;
            for( j = 0; j < 7; j++ ){
                *w++ |= *r++;
            }
            // 100subsec
            i = subsec / 100;
            w = dotmatrixdata_data + 25;
            r = (unsigned short *)dotmatrixdata_suuzi_big + i * 7;
            for( j = 0; j < 7; j++ ){
                *w++ |= *r++;
            }
            break;
        case 2:
            // 10min
            i = min / 10;
            w = dotmatrixdata_data + 0;
            r = (unsigned short *)dotmatrixdata_suuzi_big + i * 7;
            for( j = 0; j < 7; j++ ){
                *w++ |= *r++;
            }
            // 1min
            i = min % 10;
            w = dotmatrixdata_data + 8;
            r = (unsigned short *)dotmatrixdata_suuzi_big + i * 7;
            for( j = 0; j < 7; j++ ){
                *w++ |= *r++;
            }
            // 10sec
            i = sec / 10;
            w = dotmatrixdata_data + 18;
            r = (unsigned short *)dotmatrixdata_suuzi_big + i * 7;
            for( j = 0; j < 7; j++ ){
                *w++ |= *r++;
            }
            // 1sec
            i = sec % 10;
            w = dotmatrixdata_data + 25;
            r = (unsigned short *)dotmatrixdata_suuzi_big + i * 7;
            for( j = 0; j < 7; j++ ){
                *w++ |= *r++;
            }
            break;
        case 3:
            // 10min
            i = min / 10;
            w = dotmatrixdata_data + 0;
            r = (unsigned short *)dotmatrixdata_suuzi_down + i * 4;
            for( j = 0; j < 4; j++ ){
                *w++ |= *r++;
            }

            // 1min
            i = min % 10;
            w = dotmatrixdata_data + 4;
            r = (unsigned short *)dotmatrixdata_suuzi_down + i * 4;
            for( j = 0; j < 4; j++ ){
                *w++ |= *r++;
            }
            
            // 10sec
            i = sec / 10;
            w = dotmatrixdata_data + 10;
            r = (unsigned short *)dotmatrixdata_suuzi_down + i * 4;
            for( j = 0; j < 4; j++ ){
                *w++ |= *r++;
            }

            // 1sec
            i = sec % 10;
            w = dotmatrixdata_data + 14;
            r = (unsigned short *)dotmatrixdata_suuzi_down + i * 4;
            for( j = 0; j < 4; j++ ){
                *w++ |= *r++;
            }
            
            // 100subsec
            i = subsec / 100;
            w = dotmatrixdata_data + 20;
            r = (unsigned short *)dotmatrixdata_suuzi_down + i * 4;
            for( j = 0; j < 4; j++ ){
                *w++ |= *r++;
            }

            // 10subsec
            i = subsec / 10;
            i = i % 10;
            w = dotmatrixdata_data + 24;
            r = (unsigned short *)dotmatrixdata_suuzi_down + i * 4;
            for( j = 0; j < 4; j++ ){
                *w++ |= *r++;
            }

            // 1subsec
            i = subsec % 10;
            w = dotmatrixdata_data + 28;
            r = (unsigned short *)dotmatrixdata_suuzi_down + i * 4;
            for( j = 0; j < 4; j++ ){
                *w++ |= *r++;
            }
            break;
    }
    
    if( SENSOR == 1 ) {
        // ZTAEɃhbg\
        dotmatrixdata_data[ 31 ] |= 0x0003;
        dotmatrixdata_data[ 30 ] |= 0x0003;
    }
}

//------------------------------------------------------------------------------
// ^C֌W̃f[^AtOAꊇNA
//------------------------------------------------------------------------------
void clearTimeData( void )
{
    clock_flag = 0;
    f_start = 0;
    f_goal = 0;
    sensor_cnt = 0;
    mode_t    = 0;
    min     = 0;
    sec     = 0;
    subsec  = 0;
}

//------------------------------------------------------------------------------
// hbg}gNXLED\
//          \z̃|C^
// ߂l       Ȃ
//------------------------------------------------------------------------------
void dotmatrix( unsigned short *data1 )
{
    unsigned short  rowa_sin;
    unsigned short  rowb_sin;
    unsigned short  col_sin;
    int             y;

    rowa_sin = data1[dotmatrix_x];
    rowb_sin = data1[dotmatrix_x+16];
    col_sin = 1 << ( 15 - dotmatrix_x );

    for( y = 0; y < 16; y++ ){

        p6_3 = (rowa_sin >> 15) & 0x0001;
        rowa_sin = rowa_sin << 1;

        p6_2 = (rowb_sin >> 15) & 0x0001;
        rowb_sin = rowb_sin << 1;

        p6_1 = col_sin & 0x0001;
        col_sin = col_sin >> 1;

        // NbN̗ŃVtgWX^Ƀ[h
        p6_4 = 0;
        p6_4 = 1;
    }

    // VtgWX^̃f[^b`
    p6_6 = 0;
    p6_6 = 1;

    dotmatrix_x++;
    if( dotmatrix_x >= 16 ) dotmatrix_x = 0;
}

//------------------------------------------------------------------------------
// hbg}gNXLED\(180])
//          \z̃|C^
// ߂l       Ȃ
//------------------------------------------------------------------------------
void dotmatrix_reverse( unsigned short *data1 )
{
    unsigned short  rowa_sin;
    unsigned short  rowb_sin;
    unsigned short  col_sin;
    int             y;

    rowa_sin = data1[dotmatrix_x];
    rowb_sin = data1[dotmatrix_x+16];
    col_sin = 1 << dotmatrix_x;

    for( y = 0; y < 16; y++ ){

        p6_2 = rowa_sin & 0x0001;
        rowa_sin = rowa_sin >> 1;

        p6_3 = rowb_sin & 0x0001;
        rowb_sin = rowb_sin >> 1;

        p6_1 = col_sin & 0x0001;
        col_sin = col_sin >> 1;

        // NbN̗ŃVtgWX^Ƀ[h
        p6_4 = 0;
        p6_4 = 1;
    }

    // VtgWX^̃f[^b`
    p6_6 = 0;
    p6_6 = 1;

    dotmatrix_x++;
    if( dotmatrix_x >= 16 ) dotmatrix_x = 0;
}

//------------------------------------------------------------------------------
// end of file                                                         
//------------------------------------------------------------------------------
